import urllib.request as urllib2
from queue import LifoQueue
from bs4 import BeautifulSoup

adjList = dict()

queue = LifoQueue()
queue.put("426202")

while len(adjList) <= 1000:
    userID = queue.get()
    recUrl = "https://www.tarafdari.com/user/" + userID + "/follow/followers"
    request = urllib2.Request(recUrl)
    url = urllib2.urlopen(request)
    soup = BeautifulSoup(str(url.read()), 'html.parser')
    followers = soup.find(id='page-user').next.next_sibling.next_sibling.next_sibling.find('div').find_all('a')
    print(len(adjList), ": ", recUrl)
    for tag in followers:
        tagStr = str(tag['href'])
        adjID = tagStr[tagStr.rfind('/') + 1:]
        if userID not in adjList.keys():
            adjList[userID] = set()
        if adjID not in adjList.keys():
            queue.put(adjID)
        else:
            print("Is exist: ", adjID)
        adjList[userID].add(adjID)

fout = open("adjList.txt", 'w')
for key in adjList:
    for val in adjList[key]:
        str = key + " " + val
        if key != val:
            fout.write(str + "\n")
fout.close()